#include "miscellaneous.h"

//dsString q2d( const QString &s )
//{
//    return dsString( s.toStdWString().c_str() );
//}
//
//QString d2q( const dsString &s )
//{
//    return QString::fromWCharArray((const wchar_t*)s);
//}

std::wstring d2s( const dsObjectType_e &type )
{
    switch (type)
    {
	case dsObjectUndefinedType: return L"dsObjectUndefinedType";
    case dsApplicationType: return L"dsApplicationType";
    case dsDocumentType: return L"dsDocumentType"; 
    case dsModelType: return L"dsModelType"; 
    case dsSheetType: return L"dsSheetType";
    case dsSelectionManagerType: return L"dsSelectionManagerType";
    case dsBlockDefinitionType: return L"dsBlockDefinitionType";
    case dsBlockInstanceType: return L"dsBlockInstanceType";
    case dsAttributeDefinitionType: return L"dsAttributeDefinitionType";
    case dsExternalReferenceType: return L"dsExternalReferenceType";
    case dsAttributeInstanceType: return L"dsAttributeInstanceType";
    case dsPrintManagerType: return L"dsPrintManagerType";
    case dsSketchManagerType: return L"dsSketchManagerType";
    case dsReferenceImageType: return L"dsReferenceImageType";
    case dsDocumentExporterType: return L"dsDocumentExporterType";
    case dsCommandType: return L"dsCommandType";
    case dsUserCommandType: return L"dsUserCommandType";
    case dsMenuItemType: return L"dsMenuItemType";
    case dsToolbarType: return L"dsToolbarType";
    case dsToolbarItemType: return L"dsToolbarItemType";
    case dsCommandMessageType: return L"dsCommandMessageType";		
    case dsLineType: return L"dsLineType";		
    case dsCircleType: return L"dsCircleType";
    case dsCircleArcType: return L"dsCircleArcType";
    case dsSimpleNoteType: return L"dsSimpleNoteType";
    case dsPointType: return L"dsPointType";
    case dsEllipseArcType: return L"dsEllipseArcType";
    case dsPolyLineType: return L"dsPolyLineType";
    case dsRayType: return L"dsRayType";
    case dsInfiniteLineType: return L"dsInfiniteLineType";
    case dsNoteType: return L"dsNoteType";		
    case dsLayerType: return L"dsLayerType";
    case dsColorType: return L"dsColorType";
    case dsLayerManagerType: return L"dsLayerManagerType";
    case dsTextStyleManagerType: return L"dsTextStyleManagerType";
    case dsTextStyleType: return L"dsTextStyleType";
    case dsDimensionStyleType: return L"dsDimensionStyleType";
    case dsDimensionStyleManagerType: return L"dsDimensionStyleManagerType";
    case dsSelectionFilterType: return L"dsSelectionFilterType";
    case dsRichLineType: return L"dsRichLineType";
    case dsRichLineStyleType: return L"dsRichLineStyleType";
    case dsRichLineStyleManagerType: return L"dsRichLineStyleManagerType";
    case dsCustomDataType: return L"dsCustomDataType";
    case dsDimensionStyleAngularDimensionOptionsType: return L"dsDimensionStyleAngularDimensionOptionsType";
    case dsDimensionStyleArrowsOptionsType: return L"dsDimensionStyleArrowsOptionsType";
    case dsDimensionStyleDualDimensionOptionsType: return L"dsDimensionStyleDualDimensionOptionsType";
    case dsDimensionStyleLinearDimensionOptionsType: return L"dsDimensionStyleLinearDimensionOptionsType";
    case dsDimensionStyleRadialDiameterDimensionOptionsType: return L"dsDimensionStyleRadialDiameterDimensionOptionsType";
    case dsDimensionStyleFitOptionsType: return L"dsDimensionStyleFitOptionsType";
    case dsDimensionStyleLineOptionsType: return L"dsDimensionStyleLineOptionsType";
    case dsDimensionStyleTextOptionsType: return L"dsDimensionStyleTextOptionsType";
    case dsDimensionStyleToleranceOptionsType: return L"dsDimensionStyleToleranceOptionsType";
    case dsAngularDimensionType: return L"dsAngularDimensionType";
    case dsGeneralDimensionType: return L"dsGeneralDimensionType";		
    case dsAlignedDimensionType: return L"dsAlignedDimensionType";
    case dsRotatedDimensionType: return L"dsRotatedDimensionType";
    case dsArcLengthDimensionType: return L"dsArcLengthDimensionType";
    case dsDiameterDimensionType: return L"dsDiameterDimensionType";
    case dsRadialDimensionType: return L"dsRadialDimensionType";
    case dsJoggedDimensionType: return L"dsJoggedDimensionType";
    case dsOrdinateDimensionType: return L"dsOrdinateDimensionType";
    case dsLeaderType: return L"dsLeaderType";
    case dsToleranceType: return L"dsToleranceType";
    case dsCustomPropertyControlType: return L"dsCustomPropertyControlType";
    case dsHyperLinkType: return L"dsHyperLinkType";
    case dsPolyLine3DType: return L"dsPolyLine3DType";
    case dsSplineType: return L"dsSplineType";
    case dsFaceType: return L"dsFaceType";
    case dsSolidType: return L"dsSolidType";
    case dsPolygonMeshType: return L"dsPolygonMeshType";
    case dsPolyFaceMeshType: return L"dsPolyFaceMeshType";
    case dsHatchType: return L"dsHatchType";
    case dsHatchPatternType: return L"dsHatchPatternType";
    case dsHatchBoundaryLoopType: return L"dsHatchBoundaryLoopType";
    case dsMathUtilityType: return L"dsMathUtilityType";
    case dsMathTransformType: return L"dsMathTransformType";
    case dsMathPointType: return L"dsMathPointType";
    case dsMathLineType: return L"dsMathLineType";
    case dsMathVectorType: return L"dsMathVectorType";
    case dsMathPlaneType: return L"dsMathPlaneType";
    case dsCustomCoordinateSystemManagerType: return L"dsCustomCoordinateSystemManagerType";
    case dsCustomCoordinateSystemType: return L"dsCustomCoordinateSystemType";
    case dsViewManagerType: return L"dsViewManagerType";
    case dsNamedViewType: return L"dsNamedViewType";
    case dsModelNamedViewType: return L"dsModelNamedViewType";
    case dsSheetNamedViewType: return L"dsSheetNamedViewType";
    case dsEmbeddedObjectType: return L"dsEmbeddedObjectType";
    case dsDSWindowType: return L"dsDSWindowType";
    case dsRegionType: return L"dsRegionType";
    case dsTableType: return L"dsTableType";
    case dsSystemFilesType: return L"dsSystemFilesType";
    case dsTableStyleType: return L"dsTableStyleType";
    case dsTableStyleManagerType: return L"dsTableStyleManagerType";
    case dsViewportType: return L"dsViewportType";
    case dsEntityHelperType: return L"dsEntityHelperType";
    case dsGroupType: return L"dsGroupType";
    case dsApplicationOptionsType: return L"dsApplicationOptionsType";
    case dsTrackerType: return L"dsTrackerType";
    case dsDictionaryType: return L"dsDictionaryType";
    case dsXRecordType: return L"dsXRecordType";
    case dsShapeType: return L"dsShapeType";
    case dsLineStyleType: return L"dsLineStyleType";
    case dsLineStyleManagerType: return L"dsLineStyleManagerType";
    case dsShapeManagerType: return L"dsShapeManagerType";
    case dsLispFunctionType: return L"dsLispFunctionType";
    case dsLispParameterType: return L"dsLispParameterType";
    case dsDimensionStyleUserDataType: return L"dsDimensionStyleUserDataType";
    case dsMathCircArcType: return L"dsMathCircArcType";
    case dsMathEllipArcType: return L"dsMathEllipArcType";
    case dsDrawingSupportFilesType: return L"dsDrawingSupportFilesType";
    case dsInterfaceFilesType: return L"dsInterfaceFilesType";
    case dsTraceType: return L"dsTraceType";
    case dsContextMenuItemType: return L"dsContextMenuItemType";
    case dsHighlightSetType: return L"dsHighlightSetType";
    case dsMacroManagerType: return L"dsMacroManagerType";
    case dsColorPickerType: return L"dsColorPickerType";
    case dsDrawingPropertiesType: return L"dsDrawingPropertiesType";
//     case dsSolidBackgroundType: return QString::fromLatin1("dsSolidBackgroundType");
//     case dsGradientBackgroundType: return QString::fromLatin1("dsGradientBackgroundType");
//     case dsImageBackgroundType: return QString::fromLatin1("dsImageBackgroundType");
    default: return L"Type is unknown (Maybe not synchronous to dsObjectType_e?)";
    }
}

std::wstring d2s( const dsCustomDataType_e &type )
{
    switch (type)
    {
    case dsCustomDataType_Unknown: return L"dsCustomDataType_Unknown";
    case dsCustomDataType_String: return L"dsCustomDataType_String";
    case dsCustomDataType_Integer16: return L"dsCustomDataType_Integer16";
    case dsCustomDataType_Integer32: return L"dsCustomDataType_Integer32";
    case dsCustomDataType_Double: return L"dsCustomDataType_Double";
    case dsCustomDataType_Point: return L"dsCustomDataType_Point";
    case dsCustomDataType_BinaryData: return L"dsCustomDataType_BinaryData";
    case dsCustomDataType_LayerName: return L"dsCustomDataType_LayerName";
    case dsCustomDataType_Handle: return L"dsCustomDataType_Handle";
    case dsCustomDataType_CustomData: return L"dsCustomDataType_CustomData";
    case dsCustomDataType_Integer8: return L"dsCustomDataType_Integer8";
    case dsCustomDataType_Integer64: return L"dsCustomDataType_Integer64";
    default: return L"Unknown: %1 (Maybe not synchronous to dsCustomDataType_e?)";
    }
}
