//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsAttributeInstance.js, JavaScript API dsAttributeInstance interface
//

djObjectExtendCollection.dsAttributeInstance = djAttributeInstanceExtend;

function djAttributeInstanceExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.get_Layer = function() {return djProcessCommand(this, 'get_Layer', arguments); };
	dsObj.put_Layer = function(NewVal) {return djProcessCommand(this, 'put_Layer', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_LineScale = function() {return djProcessCommand(this, 'get_LineScale', arguments); };
	dsObj.put_LineScale = function(NewVal) {return djProcessCommand(this, 'put_LineScale', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	dsObj.get_Visible = function() {return djProcessCommand(this, 'get_Visible', arguments); };
	dsObj.put_Visible = function(NewVal) {return djProcessCommand(this, 'put_Visible', arguments); };
	dsObj.Select = function(SelectFlag) {return djProcessCommand(this, 'Select', arguments); };
	dsObj.GetName = function() {return djProcessCommand(this, 'GetName', arguments); };
	dsObj.get_Value = function() {return djProcessCommand(this, 'get_Value', arguments); };
	dsObj.put_Value = function(NewVal) {return djProcessCommand(this, 'put_Value', arguments); };
	dsObj.get_Color = function() {return djProcessCommand(this, 'get_Color', arguments); };
	dsObj.put_Color = function(NewVal) {return djProcessCommand(this, 'put_Color', arguments); };
	dsObj.get_Erased = function() {return djProcessCommand(this, 'get_Erased', arguments); };
	dsObj.put_Erased = function(NewVal) {return djProcessCommand(this, 'put_Erased', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.GetHyperLink = function() {return djProcessCommand(this, 'GetHyperLink', arguments); };
	dsObj.SetHyperLink = function(HyperLink) {return djProcessCommand(this, 'SetHyperLink', arguments); };
	dsObj.DeleteHyperLink = function() {return djProcessCommand(this, 'DeleteHyperLink', arguments); };
	dsObj.GetBoundingBox = function() {return djProcessCommand(this, 'GetBoundingBox', arguments); };
	dsObj.get_Thickness = function() {return djProcessCommand(this, 'get_Thickness', arguments); };
	dsObj.put_Thickness = function(Val) {return djProcessCommand(this, 'put_Thickness', arguments); };
	dsObj.get_Constant = function() {return djProcessCommand(this, 'get_Constant', arguments); };
	dsObj.get_TextStyle = function() {return djProcessCommand(this, 'get_TextStyle', arguments); };
	dsObj.put_TextStyle = function(NewVal) {return djProcessCommand(this, 'put_TextStyle', arguments); };
	dsObj.get_Justification = function() {return djProcessCommand(this, 'get_Justification', arguments); };
	dsObj.put_Justification = function(NewVal) {return djProcessCommand(this, 'put_Justification', arguments); };
	dsObj.get_Height = function() {return djProcessCommand(this, 'get_Height', arguments); };
	dsObj.put_Height = function(NewVal) {return djProcessCommand(this, 'put_Height', arguments); };
	dsObj.get_Rotation = function() {return djProcessCommand(this, 'get_Rotation', arguments); };
	dsObj.put_Rotation = function(NewVal) {return djProcessCommand(this, 'put_Rotation', arguments); };
	dsObj.get_Backwards = function() {return djProcessCommand(this, 'get_Backwards', arguments); };
	dsObj.put_Backwards = function(NewVal) {return djProcessCommand(this, 'put_Backwards', arguments); };
	dsObj.get_UpsideDown = function() {return djProcessCommand(this, 'get_UpsideDown', arguments); };
	dsObj.put_UpsideDown = function(NewVal) {return djProcessCommand(this, 'put_UpsideDown', arguments); };
	dsObj.GetPosition = function() {return djProcessCommand(this, 'GetPosition', arguments); };
	dsObj.SetPosition = function(X, Y, Z) {return djProcessCommand(this, 'SetPosition', arguments); };
	dsObj.GetNormal = function() {return djProcessCommand(this, 'GetNormal', arguments); };
	dsObj.SetNormal = function(Normal) {return djProcessCommand(this, 'SetNormal', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.GetAlignmentPoint = function() {return djProcessCommand(this, 'GetAlignmentPoint', arguments); };
	dsObj.SetAlignmentPoint = function(X, Y, Z) {return djProcessCommand(this, 'SetAlignmentPoint', arguments); };
	dsObj.get_Angle = function() {return djProcessCommand(this, 'get_Angle', arguments); };
	dsObj.put_Angle = function(NewVal) {return djProcessCommand(this, 'put_Angle', arguments); };
	dsObj.get_Spacing = function() {return djProcessCommand(this, 'get_Spacing', arguments); };
	dsObj.put_Spacing = function(NewVal) {return djProcessCommand(this, 'put_Spacing', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.get_Multilines = function() {return djProcessCommand(this, 'get_Multilines', arguments); };
	dsObj.get_Text = function() {return djProcessCommand(this, 'get_Text', arguments); };
	dsObj.put_Text = function(NewVal) {return djProcessCommand(this, 'put_Text', arguments); };
	//Add forward methods above this line
}
