//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsCustomData.js, JavaScript API dsCustomData interface
//

djObjectExtendCollection.dsCustomData = djCustomDataExtend;

function djCustomDataExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.GetDataCount = function() {return djProcessCommand(this, 'GetDataCount', arguments); };
	dsObj.GetDataMarker = function(Index) {return djProcessCommand(this, 'GetDataMarker', arguments); };
	dsObj.GetDataType = function(Index) {return djProcessCommand(this, 'GetDataType', arguments); };
	dsObj.GetStringData = function(Index) {return djProcessCommand(this, 'GetStringData', arguments); };
	dsObj.GetInteger16Data = function(Index) {return djProcessCommand(this, 'GetInteger16Data', arguments); };
	dsObj.GetInteger32Data = function(Index) {return djProcessCommand(this, 'GetInteger32Data', arguments); };
	dsObj.GetDoubleData = function(Index) {return djProcessCommand(this, 'GetDoubleData', arguments); };
	dsObj.GetPointData = function(Index) {return djProcessCommand(this, 'GetPointData', arguments); };
	dsObj.GetLayerName = function(Index) {return djProcessCommand(this, 'GetLayerName', arguments); };
	dsObj.GetCustomData = function(Index) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.Empty = function() {return djProcessCommand(this, 'Empty', arguments); };
	dsObj.Delete = function(Index) {return djProcessCommand(this, 'Delete', arguments); };
	dsObj.SetStringData = function(Index, Value) {return djProcessCommand(this, 'SetStringData', arguments); };
	dsObj.SetInteger16Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger16Data', arguments); };
	dsObj.SetInteger32Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger32Data', arguments); };
	dsObj.SetDoubleData = function(Index, Value) {return djProcessCommand(this, 'SetDoubleData', arguments); };
	dsObj.SetPointData = function(Index, X, Y, Z) {return djProcessCommand(this, 'SetPointData', arguments); };
	dsObj.SetLayerName = function(Index, Value) {return djProcessCommand(this, 'SetLayerName', arguments); };
	dsObj.InsertStringData = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertStringData', arguments); };
	dsObj.InsertInteger16Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger16Data', arguments); };
	dsObj.InsertInteger32Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger32Data', arguments); };
	dsObj.InsertDoubleData = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertDoubleData', arguments); };
	dsObj.InsertPointData = function(Index, Marker, X, Y, Z) {return djProcessCommand(this, 'InsertPointData', arguments); };
	dsObj.InsertLayerName = function(Index, Value) {return djProcessCommand(this, 'InsertLayerName', arguments); };
	dsObj.InsertCustomData = function(Index) {return djProcessCommand(this, 'InsertCustomData', arguments); };
	dsObj.GetByteData = function(Index) {return djProcessCommand(this, 'GetByteData', arguments); };
	dsObj.GetHandleData = function(Index) {return djProcessCommand(this, 'GetHandleData', arguments); };
	dsObj.SetByteData = function(Index, ByteArray) {return djProcessCommand(this, 'SetByteData', arguments); };
	dsObj.SetHandle = function(Index, Handle) {return djProcessCommand(this, 'SetHandle', arguments); };
	dsObj.InsertByteData = function(Index, ByteArray) {return djProcessCommand(this, 'InsertByteData', arguments); };
	dsObj.InsertHandle = function(Index, Handle) {return djProcessCommand(this, 'InsertHandle', arguments); };
	//Add forward methods above this line
}
