//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsEntityHelper.js, JavaScript API dsEntityHelper interface
//

djObjectExtendCollection.dsEntityHelper = djEntityHelperExtend;

function djEntityHelperExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.GetColor = function(Obj) {return djProcessCommand(this, 'GetColor', arguments); };
	dsObj.SetColor = function(Obj, NewVal) {return djProcessCommand(this, 'SetColor', arguments); };
	dsObj.GetLayer = function(Obj) {return djProcessCommand(this, 'GetLayer', arguments); };
	dsObj.SetLayer = function(Obj, NewVal) {return djProcessCommand(this, 'SetLayer', arguments); };
	dsObj.GetLineStyle = function(Obj) {return djProcessCommand(this, 'GetLineStyle', arguments); };
	dsObj.SetLineStyle = function(Obj, Val) {return djProcessCommand(this, 'SetLineStyle', arguments); };
	dsObj.GetVisible = function(Obj) {return djProcessCommand(this, 'GetVisible', arguments); };
	dsObj.SetVisible = function(Obj, NewVal) {return djProcessCommand(this, 'SetVisible', arguments); };
	dsObj.GetLineWeight = function(Obj) {return djProcessCommand(this, 'GetLineWeight', arguments); };
	dsObj.SetLineWeight = function(Obj, NewVal) {return djProcessCommand(this, 'SetLineWeight', arguments); };
	dsObj.GetCustomData = function(Obj, ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(Obj, ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.Select = function(Obj, SelectFlag) {return djProcessCommand(this, 'Select', arguments); };
	dsObj.GetHyperLink = function(Obj) {return djProcessCommand(this, 'GetHyperLink', arguments); };
	dsObj.SetHyperLink = function(Obj, HyperLink) {return djProcessCommand(this, 'SetHyperLink', arguments); };
	dsObj.DeleteCustomData = function(Obj, ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.DeleteHyperLink = function(Obj) {return djProcessCommand(this, 'DeleteHyperLink', arguments); };
	dsObj.CompareObjects = function(Obj1, Obj2) {return djProcessCommand(this, 'CompareObjects', arguments); };
	dsObj.GetHandle = function(Obj) {return djProcessCommand(this, 'GetHandle', arguments); };
	dsObj.GetErased = function(Obj) {return djProcessCommand(this, 'GetErased', arguments); };
	dsObj.SetErased = function(Obj, NewVal) {return djProcessCommand(this, 'SetErased', arguments); };
	dsObj.CreateExtensionDictionary = function(Obj) {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function(Obj) {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function(Obj) {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.GetPrintStyle = function(Obj) {return djProcessCommand(this, 'GetPrintStyle', arguments); };
	dsObj.SetPrintStyle = function(Obj, Val) {return djProcessCommand(this, 'SetPrintStyle', arguments); };
	dsObj.GetTransparency = function(Obj) {return djProcessCommand(this, 'GetTransparency', arguments); };
	dsObj.SetTransparency = function(Obj, Val) {return djProcessCommand(this, 'SetTransparency', arguments); };
	//Add forward methods above this line
}
