//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsLayer.js, JavaScript API dsLayer interface
//

djObjectExtendCollection.dsLayer = djLayerExtend;

function djLayerExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.get_Name = function() {return djProcessCommand(this, 'get_Name', arguments); };
	dsObj.get_Shown = function() {return djProcessCommand(this, 'get_Shown', arguments); };
	dsObj.put_Shown = function(NewVal) {return djProcessCommand(this, 'put_Shown', arguments); };
	dsObj.get_Frozen = function() {return djProcessCommand(this, 'get_Frozen', arguments); };
	dsObj.put_Frozen = function(NewVal) {return djProcessCommand(this, 'put_Frozen', arguments); };
	dsObj.get_Locked = function() {return djProcessCommand(this, 'get_Locked', arguments); };
	dsObj.put_Locked = function(NewVal) {return djProcessCommand(this, 'put_Locked', arguments); };
	dsObj.get_Printable = function() {return djProcessCommand(this, 'get_Printable', arguments); };
	dsObj.put_Printable = function(NewVal) {return djProcessCommand(this, 'put_Printable', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.get_Description = function() {return djProcessCommand(this, 'get_Description', arguments); };
	dsObj.put_Description = function(NewVal) {return djProcessCommand(this, 'put_Description', arguments); };
	dsObj.Rename = function(Name) {return djProcessCommand(this, 'Rename', arguments); };
	dsObj.Activate = function() {return djProcessCommand(this, 'Activate', arguments); };
	dsObj.get_Color = function() {return djProcessCommand(this, 'get_Color', arguments); };
	dsObj.put_Color = function(NewVal) {return djProcessCommand(this, 'put_Color', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.get_FrozenInNewViewport = function() {return djProcessCommand(this, 'get_FrozenInNewViewport', arguments); };
	dsObj.put_FrozenInNewViewport = function(NewVal) {return djProcessCommand(this, 'put_FrozenInNewViewport', arguments); };
	dsObj.GetFrozenInViewport = function(Viewport) {return djProcessCommand(this, 'GetFrozenInViewport', arguments); };
	dsObj.SetFrozenInViewport = function(IsFrozen, Viewport) {return djProcessCommand(this, 'SetFrozenInViewport', arguments); };
	dsObj.GetColorInViewport = function(Viewport) {return djProcessCommand(this, 'GetColorInViewport', arguments); };
	dsObj.SetColorInViewport = function(Color, Viewport) {return djProcessCommand(this, 'SetColorInViewport', arguments); };
	dsObj.GetLineSyleInViewport = function(Viewport) {return djProcessCommand(this, 'GetLineSyleInViewport', arguments); };
	dsObj.SetLineStyleInViewport = function(LineStyle, Viewport) {return djProcessCommand(this, 'SetLineStyleInViewport', arguments); };
	dsObj.GetLineWeightInViewport = function(Viewport) {return djProcessCommand(this, 'GetLineWeightInViewport', arguments); };
	dsObj.SetLineWeightInViewport = function(LineWeight, Viewport) {return djProcessCommand(this, 'SetLineWeightInViewport', arguments); };
	dsObj.GetTranparencyInViewport = function(Viewport) {return djProcessCommand(this, 'GetTranparencyInViewport', arguments); };
	dsObj.SetTranparencyInViewport = function(Transparency, Viewport) {return djProcessCommand(this, 'SetTranparencyInViewport', arguments); };
	dsObj.GetPrintStyleInViewport = function(Viewport) {return djProcessCommand(this, 'GetPrintStyleInViewport', arguments); };
	dsObj.SetPrintStyleInViewport = function(PrintStyle, Viewport) {return djProcessCommand(this, 'SetPrintStyleInViewport', arguments); };
	dsObj.RemoveColorOverrides = function() {return djProcessCommand(this, 'RemoveColorOverrides', arguments); };
	dsObj.RemoveColorOverride = function(Viewport) {return djProcessCommand(this, 'RemoveColorOverride', arguments); };
	dsObj.RemoveLineStyleOverrides = function() {return djProcessCommand(this, 'RemoveLineStyleOverrides', arguments); };
	dsObj.RemoveLineStyleOverride = function(Viewport) {return djProcessCommand(this, 'RemoveLineStyleOverride', arguments); };
	dsObj.RemoveLineWeightOverrides = function() {return djProcessCommand(this, 'RemoveLineWeightOverrides', arguments); };
	dsObj.RemoveLineWeightOverride = function(Viewport) {return djProcessCommand(this, 'RemoveLineWeightOverride', arguments); };
	dsObj.RemoveTransparencyOverrides = function() {return djProcessCommand(this, 'RemoveTransparencyOverrides', arguments); };
	dsObj.RemoveTransparencyOverride = function(Viewport) {return djProcessCommand(this, 'RemoveTransparencyOverride', arguments); };
	dsObj.RemovePrintStyleOverrides = function() {return djProcessCommand(this, 'RemovePrintStyleOverrides', arguments); };
	dsObj.RemovePrintStyleOverride = function(Viewport) {return djProcessCommand(this, 'RemovePrintStyleOverride', arguments); };
	//Add forward methods above this line
}
