//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsLayerManager.js, JavaScript API dsLayerManager interface
//

djObjectExtendCollection.dsLayerManager = djLayerManagerExtend;

function djLayerManagerExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.CreateLayer = function(Name) {return djProcessCommand(this, 'CreateLayer', arguments); };
	dsObj.GetLayer = function(Name) {return djProcessCommand(this, 'GetLayer', arguments); };
	dsObj.GetActiveLayer = function() {return djProcessCommand(this, 'GetActiveLayer', arguments); };
	dsObj.GetLayers = function() {return djProcessCommand(this, 'GetLayers', arguments); };
	dsObj.RemoveLayer = function(Name) {return djProcessCommand(this, 'RemoveLayer', arguments); };
	dsObj.RemoveAllOverrides = function(LayerArray) {return djProcessCommand(this, 'RemoveAllOverrides', arguments); };
	dsObj.RemoveViewportOverrides = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemoveViewportOverrides', arguments); };
	dsObj.RemoveColorOverrides = function(LayerArray) {return djProcessCommand(this, 'RemoveColorOverrides', arguments); };
	dsObj.RemoveColorOverride = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemoveColorOverride', arguments); };
	dsObj.RemoveLineStyleOverrides = function(LayerArray) {return djProcessCommand(this, 'RemoveLineStyleOverrides', arguments); };
	dsObj.RemoveLineStyleOverride = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemoveLineStyleOverride', arguments); };
	dsObj.RemoveLineWeightOverrides = function(LayerArray) {return djProcessCommand(this, 'RemoveLineWeightOverrides', arguments); };
	dsObj.RemoveLineWeightOverride = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemoveLineWeightOverride', arguments); };
	dsObj.RemoveTransparencyOverrides = function(LayerArray) {return djProcessCommand(this, 'RemoveTransparencyOverrides', arguments); };
	dsObj.RemoveTransparencyOverride = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemoveTransparencyOverride', arguments); };
	dsObj.RemovePrintStyleOverrides = function(LayerArray) {return djProcessCommand(this, 'RemovePrintStyleOverrides', arguments); };
	dsObj.RemovePrintStyleOverride = function(LayerArray, Viewport) {return djProcessCommand(this, 'RemovePrintStyleOverride', arguments); };
	//Add forward methods above this line
}
