//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsLayerState.js, JavaScript API dsLayerState interface
//

djObjectExtendCollection.dsLayerState = djLayerStateExtend;

function djLayerStateExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.Activate = function() {return djProcessCommand(this, 'Activate', arguments); };
	dsObj.AddLayer = function(LayerName) {return djProcessCommand(this, 'AddLayer', arguments); };
	dsObj.RemoveLayer = function(LayerName) {return djProcessCommand(this, 'RemoveLayer', arguments); };
	dsObj.GetLayers = function() {return djProcessCommand(this, 'GetLayers', arguments); };
	dsObj.GetLayerProperties = function(LayerName) {return djProcessCommand(this, 'GetLayerProperties', arguments); };
	dsObj.get_Name = function() {return djProcessCommand(this, 'get_Name', arguments); };
	dsObj.put_Name = function(NewVal) {return djProcessCommand(this, 'put_Name', arguments); };
	dsObj.get_Description = function() {return djProcessCommand(this, 'get_Description', arguments); };
	dsObj.put_Description = function(NewVal) {return djProcessCommand(this, 'put_Description', arguments); };
	dsObj.get_Space = function() {return djProcessCommand(this, 'get_Space', arguments); };
	dsObj.get_ShowHide = function() {return djProcessCommand(this, 'get_ShowHide', arguments); };
	dsObj.put_ShowHide = function(NewVal) {return djProcessCommand(this, 'put_ShowHide', arguments); };
	dsObj.get_FrozenThawed = function() {return djProcessCommand(this, 'get_FrozenThawed', arguments); };
	dsObj.put_FrozenThawed = function(NewVal) {return djProcessCommand(this, 'put_FrozenThawed', arguments); };
	dsObj.get_LockedUnlocked = function() {return djProcessCommand(this, 'get_LockedUnlocked', arguments); };
	dsObj.put_LockedUnlocked = function(NewVal) {return djProcessCommand(this, 'put_LockedUnlocked', arguments); };
	dsObj.get_LineColor = function() {return djProcessCommand(this, 'get_LineColor', arguments); };
	dsObj.put_LineColor = function(NewVal) {return djProcessCommand(this, 'put_LineColor', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.get_PrintNoPrint = function() {return djProcessCommand(this, 'get_PrintNoPrint', arguments); };
	dsObj.put_PrintNoPrint = function(NewVal) {return djProcessCommand(this, 'put_PrintNoPrint', arguments); };
	dsObj.get_NewViewPortFrozenThawed = function() {return djProcessCommand(this, 'get_NewViewPortFrozenThawed', arguments); };
	dsObj.put_NewViewPortFrozenThawed = function(NewVal) {return djProcessCommand(this, 'put_NewViewPortFrozenThawed', arguments); };
	dsObj.get_ActiveViewPortVisibility = function() {return djProcessCommand(this, 'get_ActiveViewPortVisibility', arguments); };
	dsObj.put_ActiveViewPortVisibility = function(NewVal) {return djProcessCommand(this, 'put_ActiveViewPortVisibility', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	//Add forward methods above this line
}
