//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsReferenceImage.js, JavaScript API dsReferenceImage interface
//

djObjectExtendCollection.dsReferenceImage = djReferenceImageExtend;

function djReferenceImageExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.get_Layer = function() {return djProcessCommand(this, 'get_Layer', arguments); };
	dsObj.put_Layer = function(NewVal) {return djProcessCommand(this, 'put_Layer', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_LineScale = function() {return djProcessCommand(this, 'get_LineScale', arguments); };
	dsObj.put_LineScale = function(NewVal) {return djProcessCommand(this, 'put_LineScale', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	dsObj.get_Visible = function() {return djProcessCommand(this, 'get_Visible', arguments); };
	dsObj.put_Visible = function(NewVal) {return djProcessCommand(this, 'put_Visible', arguments); };
	dsObj.Select = function(SelectFlag) {return djProcessCommand(this, 'Select', arguments); };
	dsObj.get_Color = function() {return djProcessCommand(this, 'get_Color', arguments); };
	dsObj.put_Color = function(NewVal) {return djProcessCommand(this, 'put_Color', arguments); };
	dsObj.get_Erased = function() {return djProcessCommand(this, 'get_Erased', arguments); };
	dsObj.put_Erased = function(NewVal) {return djProcessCommand(this, 'put_Erased', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.GetHyperLink = function() {return djProcessCommand(this, 'GetHyperLink', arguments); };
	dsObj.SetHyperLink = function(HyperLink) {return djProcessCommand(this, 'SetHyperLink', arguments); };
	dsObj.DeleteHyperLink = function() {return djProcessCommand(this, 'DeleteHyperLink', arguments); };
	dsObj.GetBoundingBox = function() {return djProcessCommand(this, 'GetBoundingBox', arguments); };
	dsObj.get_Brightness = function() {return djProcessCommand(this, 'get_Brightness', arguments); };
	dsObj.put_Brightness = function(NewVal) {return djProcessCommand(this, 'put_Brightness', arguments); };
	dsObj.get_Contrast = function() {return djProcessCommand(this, 'get_Contrast', arguments); };
	dsObj.put_Contrast = function(NewVal) {return djProcessCommand(this, 'put_Contrast', arguments); };
	dsObj.get_Fade = function() {return djProcessCommand(this, 'get_Fade', arguments); };
	dsObj.put_Fade = function(NewVal) {return djProcessCommand(this, 'put_Fade', arguments); };
	dsObj.get_Height = function() {return djProcessCommand(this, 'get_Height', arguments); };
	dsObj.put_Height = function(NewVal) {return djProcessCommand(this, 'put_Height', arguments); };
	dsObj.get_Width = function() {return djProcessCommand(this, 'get_Width', arguments); };
	dsObj.put_Width = function(NewVal) {return djProcessCommand(this, 'put_Width', arguments); };
	dsObj.get_ScaleImage = function() {return djProcessCommand(this, 'get_ScaleImage', arguments); };
	dsObj.put_ScaleImage = function(NewVal) {return djProcessCommand(this, 'put_ScaleImage', arguments); };
	dsObj.get_Rotation = function() {return djProcessCommand(this, 'get_Rotation', arguments); };
	dsObj.put_Rotation = function(NewVal) {return djProcessCommand(this, 'put_Rotation', arguments); };
	dsObj.get_ShowClipped = function() {return djProcessCommand(this, 'get_ShowClipped', arguments); };
	dsObj.put_ShowClipped = function(NewVal) {return djProcessCommand(this, 'put_ShowClipped', arguments); };
	dsObj.get_ShowImage = function() {return djProcessCommand(this, 'get_ShowImage', arguments); };
	dsObj.put_ShowImage = function(NewVal) {return djProcessCommand(this, 'put_ShowImage', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.GetPosition = function() {return djProcessCommand(this, 'GetPosition', arguments); };
	dsObj.SetPosition = function(X, Y, Z) {return djProcessCommand(this, 'SetPosition', arguments); };
	dsObj.GetPath = function() {return djProcessCommand(this, 'GetPath', arguments); };
	dsObj.SetPath = function(ImagePath) {return djProcessCommand(this, 'SetPath', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.Reload = function() {return djProcessCommand(this, 'Reload', arguments); };
	dsObj.Unload = function() {return djProcessCommand(this, 'Unload', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.SetClipBoundary = function(ClipPointsDblArray) {return djProcessCommand(this, 'SetClipBoundary', arguments); };
	dsObj.GetClipBoundary = function() {return djProcessCommand(this, 'GetClipBoundary', arguments); };
	dsObj.RemoveClipBoundary = function() {return djProcessCommand(this, 'RemoveClipBoundary', arguments); };
	//Add forward methods above this line
}
