//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsRegion.js, JavaScript API dsRegion interface
//

djObjectExtendCollection.dsRegion = djRegionExtend;

function djRegionExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.Select = function(SelectFlag) {return djProcessCommand(this, 'Select', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.GetHyperLink = function() {return djProcessCommand(this, 'GetHyperLink', arguments); };
	dsObj.SetHyperLink = function(HyperLink) {return djProcessCommand(this, 'SetHyperLink', arguments); };
	dsObj.DeleteHyperLink = function() {return djProcessCommand(this, 'DeleteHyperLink', arguments); };
	dsObj.GetBoundingBox = function() {return djProcessCommand(this, 'GetBoundingBox', arguments); };
	dsObj.GetArea = function() {return djProcessCommand(this, 'GetArea', arguments); };
	dsObj.GetPerimeter = function() {return djProcessCommand(this, 'GetPerimeter', arguments); };
	dsObj.GetPlane = function() {return djProcessCommand(this, 'GetPlane', arguments); };
	dsObj.GetNormal = function() {return djProcessCommand(this, 'GetNormal', arguments); };
	dsObj.get_Layer = function() {return djProcessCommand(this, 'get_Layer', arguments); };
	dsObj.put_Layer = function(NewVal) {return djProcessCommand(this, 'put_Layer', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_LineScale = function() {return djProcessCommand(this, 'get_LineScale', arguments); };
	dsObj.put_LineScale = function(NewVal) {return djProcessCommand(this, 'put_LineScale', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	dsObj.get_Visible = function() {return djProcessCommand(this, 'get_Visible', arguments); };
	dsObj.put_Visible = function(NewVal) {return djProcessCommand(this, 'put_Visible', arguments); };
	dsObj.get_Color = function() {return djProcessCommand(this, 'get_Color', arguments); };
	dsObj.put_Color = function(Color) {return djProcessCommand(this, 'put_Color', arguments); };
	dsObj.get_Erased = function() {return djProcessCommand(this, 'get_Erased', arguments); };
	dsObj.put_Erased = function(NewVal) {return djProcessCommand(this, 'put_Erased', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.GetCentroid = function() {return djProcessCommand(this, 'GetCentroid', arguments); };
	//Add forward methods above this line
}
