//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsViewport.js, JavaScript API dsViewport interface
//

djObjectExtendCollection.dsViewport = djViewportExtend;

function djViewportExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.get_Layer = function() {return djProcessCommand(this, 'get_Layer', arguments); };
	dsObj.put_Layer = function(NewVal) {return djProcessCommand(this, 'put_Layer', arguments); };
	dsObj.get_LineStyle = function() {return djProcessCommand(this, 'get_LineStyle', arguments); };
	dsObj.put_LineStyle = function(NewVal) {return djProcessCommand(this, 'put_LineStyle', arguments); };
	dsObj.get_LineScale = function() {return djProcessCommand(this, 'get_LineScale', arguments); };
	dsObj.put_LineScale = function(NewVal) {return djProcessCommand(this, 'put_LineScale', arguments); };
	dsObj.get_LineWeight = function() {return djProcessCommand(this, 'get_LineWeight', arguments); };
	dsObj.put_LineWeight = function(NewVal) {return djProcessCommand(this, 'put_LineWeight', arguments); };
	dsObj.get_Visible = function() {return djProcessCommand(this, 'get_Visible', arguments); };
	dsObj.put_Visible = function(NewVal) {return djProcessCommand(this, 'put_Visible', arguments); };
	dsObj.get_Color = function() {return djProcessCommand(this, 'get_Color', arguments); };
	dsObj.put_Color = function(NewVal) {return djProcessCommand(this, 'put_Color', arguments); };
	dsObj.get_Erased = function() {return djProcessCommand(this, 'get_Erased', arguments); };
	dsObj.put_Erased = function(NewVal) {return djProcessCommand(this, 'put_Erased', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.get_Height = function() {return djProcessCommand(this, 'get_Height', arguments); };
	dsObj.put_Height = function(NewVal) {return djProcessCommand(this, 'put_Height', arguments); };
	dsObj.get_Width = function() {return djProcessCommand(this, 'get_Width', arguments); };
	dsObj.put_Width = function(NewVal) {return djProcessCommand(this, 'put_Width', arguments); };
	dsObj.get_CCSPerViewport = function() {return djProcessCommand(this, 'get_CCSPerViewport', arguments); };
	dsObj.put_CCSPerViewport = function(NewVal) {return djProcessCommand(this, 'put_CCSPerViewport', arguments); };
	dsObj.get_StandardScale = function() {return djProcessCommand(this, 'get_StandardScale', arguments); };
	dsObj.put_StandardScale = function(NewVal) {return djProcessCommand(this, 'put_StandardScale', arguments); };
	dsObj.get_CustomScale = function() {return djProcessCommand(this, 'get_CustomScale', arguments); };
	dsObj.put_CustomScale = function(NewVal) {return djProcessCommand(this, 'put_CustomScale', arguments); };
	dsObj.get_DisplayLocked = function() {return djProcessCommand(this, 'get_DisplayLocked', arguments); };
	dsObj.put_DisplayLocked = function(NewVal) {return djProcessCommand(this, 'put_DisplayLocked', arguments); };
	dsObj.get_IsOn = function() {return djProcessCommand(this, 'get_IsOn', arguments); };
	dsObj.put_IsOn = function(NewVal) {return djProcessCommand(this, 'put_IsOn', arguments); };
	dsObj.get_Active = function() {return djProcessCommand(this, 'get_Active', arguments); };
	dsObj.put_Active = function(NewVal) {return djProcessCommand(this, 'put_Active', arguments); };
	dsObj.get_ShadePrintStyle = function() {return djProcessCommand(this, 'get_ShadePrintStyle', arguments); };
	dsObj.put_ShadePrintStyle = function(NewVal) {return djProcessCommand(this, 'put_ShadePrintStyle', arguments); };
	dsObj.Select = function(SelectFlag) {return djProcessCommand(this, 'Select', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.GetHyperLink = function() {return djProcessCommand(this, 'GetHyperLink', arguments); };
	dsObj.SetHyperLink = function(HyperLink) {return djProcessCommand(this, 'SetHyperLink', arguments); };
	dsObj.DeleteHyperLink = function() {return djProcessCommand(this, 'DeleteHyperLink', arguments); };
	dsObj.GetBoundingBox = function() {return djProcessCommand(this, 'GetBoundingBox', arguments); };
	dsObj.GetCenter = function() {return djProcessCommand(this, 'GetCenter', arguments); };
	dsObj.SetCenter = function(X, Y, Z) {return djProcessCommand(this, 'SetCenter', arguments); };
	dsObj.GetIsClipped = function() {return djProcessCommand(this, 'GetIsClipped', arguments); };
	dsObj.GetClippedObject = function() {return djProcessCommand(this, 'GetClippedObject', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.get_PrintStyle = function() {return djProcessCommand(this, 'get_PrintStyle', arguments); };
	dsObj.put_PrintStyle = function(NewVal) {return djProcessCommand(this, 'put_PrintStyle', arguments); };
	dsObj.get_Transparency = function() {return djProcessCommand(this, 'get_Transparency', arguments); };
	dsObj.put_Transparency = function(NewVal) {return djProcessCommand(this, 'put_Transparency', arguments); };
	dsObj.get_ViewHeight = function() {return djProcessCommand(this, 'get_ViewHeight', arguments); };
	dsObj.GetViewCenter = function() {return djProcessCommand(this, 'GetViewCenter', arguments); };
	//Add forward methods above this line
}
