//========================================================================//
//                        SOURCE CODE LICENSE                             //
//  Copyright 2017 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsXRecord.js, JavaScript API dsXRecord interface
//

djObjectExtendCollection.dsXRecord = djXRecordExtend;

function djXRecordExtend(dsObj) {
	dsObj.release =  function() { return djProcessCommand(this, 'release', arguments); };
	dsObj.Delete = function(Index) {return djProcessCommand(this, 'Delete', arguments); };
	dsObj.Empty = function() {return djProcessCommand(this, 'Empty', arguments); };
	dsObj.GetDataCount = function() {return djProcessCommand(this, 'GetDataCount', arguments); };
	dsObj.GetDataMarker = function(Index) {return djProcessCommand(this, 'GetDataMarker', arguments); };
	dsObj.GetDataType = function(Index) {return djProcessCommand(this, 'GetDataType', arguments); };
	dsObj.GetByteData = function(Index) {return djProcessCommand(this, 'GetByteData', arguments); };
	dsObj.GetDoubleData = function(Index) {return djProcessCommand(this, 'GetDoubleData', arguments); };
	dsObj.GetHandleData = function(Index) {return djProcessCommand(this, 'GetHandleData', arguments); };
	dsObj.GetInteger8Data = function(Index) {return djProcessCommand(this, 'GetInteger8Data', arguments); };
	dsObj.GetInteger16Data = function(Index) {return djProcessCommand(this, 'GetInteger16Data', arguments); };
	dsObj.GetInteger32Data = function(Index) {return djProcessCommand(this, 'GetInteger32Data', arguments); };
	dsObj.GetInteger64Data = function(Index) {return djProcessCommand(this, 'GetInteger64Data', arguments); };
	dsObj.GetPointData = function(Index) {return djProcessCommand(this, 'GetPointData', arguments); };
	dsObj.GetStringData = function(Index) {return djProcessCommand(this, 'GetStringData', arguments); };
	dsObj.InsertByteData = function(Index, Marker, ByteArray) {return djProcessCommand(this, 'InsertByteData', arguments); };
	dsObj.InsertDoubleData = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertDoubleData', arguments); };
	dsObj.InsertHandle = function(Index, Marker, Handle) {return djProcessCommand(this, 'InsertHandle', arguments); };
	dsObj.InsertInteger8Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger8Data', arguments); };
	dsObj.InsertInteger16Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger16Data', arguments); };
	dsObj.InsertInteger32Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger32Data', arguments); };
	dsObj.InsertPointData = function(Index, Marker, Point) {return djProcessCommand(this, 'InsertPointData', arguments); };
	dsObj.InsertStringData = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertStringData', arguments); };
	dsObj.SetByteData = function(Index, ByteArray) {return djProcessCommand(this, 'SetByteData', arguments); };
	dsObj.SetDoubleData = function(Index, Value) {return djProcessCommand(this, 'SetDoubleData', arguments); };
	dsObj.SetHandle = function(Index, Handle) {return djProcessCommand(this, 'SetHandle', arguments); };
	dsObj.SetInteger8Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger8Data', arguments); };
	dsObj.SetInteger16Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger16Data', arguments); };
	dsObj.SetInteger32Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger32Data', arguments); };
	dsObj.SetPointData = function(Index, Point) {return djProcessCommand(this, 'SetPointData', arguments); };
	dsObj.SetStringData = function(Index, Value) {return djProcessCommand(this, 'SetStringData', arguments); };
	dsObj.GetCustomData = function(ApplicationName) {return djProcessCommand(this, 'GetCustomData', arguments); };
	dsObj.SetCustomData = function(ApplicationName, CustomData) {return djProcessCommand(this, 'SetCustomData', arguments); };
	dsObj.DeleteCustomData = function(ApplicationName) {return djProcessCommand(this, 'DeleteCustomData', arguments); };
	dsObj.CreateExtensionDictionary = function() {return djProcessCommand(this, 'CreateExtensionDictionary', arguments); };
	dsObj.GetExtensionDictionary = function() {return djProcessCommand(this, 'GetExtensionDictionary', arguments); };
	dsObj.ReleaseExtensionDictionary = function() {return djProcessCommand(this, 'ReleaseExtensionDictionary', arguments); };
	dsObj.InsertInteger64Data = function(Index, Marker, Value) {return djProcessCommand(this, 'InsertInteger64Data', arguments); };
	dsObj.SetInteger64Data = function(Index, Value) {return djProcessCommand(this, 'SetInteger64Data', arguments); };
	dsObj.get_Handle = function() {return djProcessCommand(this, 'get_Handle', arguments); };
	dsObj.get_Erased = function() {return djProcessCommand(this, 'get_Erased', arguments); };
	dsObj.put_Erased = function(NewVal) {return djProcessCommand(this, 'put_Erased', arguments); };
	//Add forward methods above this line
}
