//========================================================================//
//         SOURCE CODE LICENSE                                            //
//  Copyright 2011 Dassault Systmes SolidWorks Corporation               //
//  All rights reserved.                                                  //
//  This software and related documentation are proprietary to            // 
//  Dassault Systmes SolidWorks Corporation                              //
//========================================================================//
// dsDimensionStyleUserData_c.h, C++ API dsDimensionStyleUserData_c interface
//

#pragma once

#include "dsinterface_global.h"
#include "dsInterfaceDefs.h"
#include "dsConstants.h"
#include "dsObject.h"

class dsDimensionStyleUserData_p;
class dsDimensionStyleUserData;
class dsDimensionStyleAngularDimensionOptions_c;
class dsDimensionStyleArrowsOptions_c;
class dsDimensionStyleDualDimensionOptions_c;
class dsDimensionStyleLinearDimensionOptions_c;
class dsDimensionStyleRadialDiameterDimensionOptions_c;
class dsDimensionStyleFitOptions_c;
class dsDimensionStyleLineOptions_c;
class dsDimensionStyleTextOptions_c;
class dsDimensionStyleToleranceOptions_c;
class DSINTERFACE_EXPORT dsDimensionStyleUserData_c : public dsObject
{
	DECLARE_DSCPP_INTERFACE(dsDimensionStyleUserData)
public:
	DSRESULT IsSame(dsDimensionStyleUserData_c* dsObj);

	DSRESULT GetDimensionStyleAngularDimensionOptions(dsDimensionStyleAngularDimensionOptions_c ** DimensionStyleAngularDimensionOptions);
	DSRESULT GetDimensionStyleArrowsOptions(dsDimensionStyleArrowsOptions_c ** DimensionStyleArrowsOptions);
	DSRESULT GetDimensionStyleDualDimensionOptions(dsDimensionStyleDualDimensionOptions_c ** DimensionStyleDualDimensionOptions);
	DSRESULT GetDimensionStyleLinearDimensionOptions(dsDimensionStyleLinearDimensionOptions_c ** DimensionStyleLinearDimensionOptions);
	DSRESULT GetDimensionStyleRadialDiameterDimensionOptions(dsDimensionStyleRadialDiameterDimensionOptions_c ** DimensionStyleRadialDiameterDimensionOptions);
	DSRESULT GetDimensionStyleFitOptions(dsDimensionStyleFitOptions_c ** DimensionStyleFitOptions);
	DSRESULT GetDimensionStyleLineOptions(dsDimensionStyleLineOptions_c ** DimensionStyleLineOptions);
	DSRESULT GetDimensionStyleTextOptions(dsDimensionStyleTextOptions_c ** DimensionStyleTextOptions);
	DSRESULT GetDimensionStyleToleranceOptions(dsDimensionStyleToleranceOptions_c ** DimensionStyleToleranceOptions);
};
